# Тасклеты MPFS

## ```projects/disk/mpfs/run_tests```
### Описание
Запускает teamcity тесты на PR или релиз.

### Вход
1. ```build``` - артефакт с параметрами с параметрами запуска тестов в teamcity
   1. ```arcanum_review_id``` - номер PR, задается если нужно запускать тесты на конкретный PR
   2. ```build_type``` - название запускаемого билда в teamcity
   3. ```release_branch``` - название релизной ветки, задается если нужно запускать тесты на релиз
   4. ```flow_type``` - тип запускаемого процесса, сейчас или ```pr``` или ```release```

### Выход
1. ```result``` - уведомление о выполнении
   1. ```msg``` 

## ```projects/disk/mpfs/create_release_branch```
### Описание
Создает релизную ветку в аркадии по пути ```arc/branches/disk/mpfs/releases```.

### Вход
1. ```config``` - артефакт с параметрами запуска
   1. ```version``` - номер версии, указывая ```auto``` для создания версии с инкрементом от предыдущей
   1. ```login``` - логин робота для работы с svn.

### Выход
1. ```release``` - артефакт релизной ветки
   1. ```version``` - версия релизной ветки.

## ```projects/disk/mpfs/create_st_ticket```
### Описание
Создает тикет в Startrek.

### Вход
1. ```config``` - артефакт с параметрами для создания тикета
   1. ```package``` - тип релиза; ```disk``` или ```platform```
   1. ```st_queue_name``` - название очереди в startrek
   1. ```follower_logins``` - список фолловеров
   1. ```following_maillists``` - список рассылок
   1. ```version``` - версия релиза


### Выход
1. ```st_ticket``` - артефакт с созданым тикетом ST 
   1. ```name``` - номер тикета
   1. ```action```

## ```projects/disk/mpfs/create_conductor_ticket```
### Описание
Создаёт кондукторный тикет на основе ранее собранных Deb-пакетов.

### Вход
1. ```config``` - артефакт с параметрами, специфичными для mpfs
   1. ```package``` - название пакета, сейчас или ```disk``` или ```platform```
   1. ```release_version``` - версия релиза, например ```2.787```
   1. ```need_last_version``` - указывается ```true
   ```, если нужно взять последний собраный пакет указанной версии иначе берется из артефакта ```ticket```
1. ```ticket``` - артефакт, в котором содержатся параметры создаваемого кондукторного тикета
   1. ```branch``` - ветка репозитория - одна из ```unstable```, ```testing```, ```prestable```, ```stable```, ```hotfix```, ```fallback```
   1. ```packages_to_remove``` - список строк - имена пакетов для удаления
   1. ```mailcc``` -  список строк - email-адреса для нотификаций
   1. ```skip_restart``` - если ```true```, то не перезапускать сервисы
   1. ```no_autoinstall``` - если ```true```, то не начинать автовыкладку
   1. ```projects``` -  список строк - наименования проектов
   1. ```comment``` - комментарий к тикету
   1. ```package``` - название пакета
   1. ```version``` - указание версии пакета

### Выход
1. ```result``` - артефакт типа ```TicketDescriptor```, который может использоваься для ожидания завершения выкладки
   1. ```name``` - имя - идентификатор созданного кондукторного тикета
